﻿				-- Author      : Alogon
-- Create Date : 3/30/2013 1:20:22 PM

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function explode(div,str) -- credit: http://richard.warburton.it
  if (div=='') then return false end
  local pos,arr = 0,{}
  -- for each divider found
  for st,sp in function() return string.find(str,div,pos,true) end do
    table.insert(arr,string.sub(str,pos,st-1)) -- Attach chars left of current divider
    pos = sp + 1 -- Jump past current divider
  end
  table.insert(arr,string.sub(str,pos)) -- Attach chars right of last divider
  return arr
end

function GENERAL_CHAT_DISPLAY_CAT(text, type) 
	if lastFight == nil or next(lastFight) == nil then
		BLTRCD_ACTIVE_NAME:SetText(text.." - Fight : No Last Fight")
		return
	end

	BLTRCD_ACTIVE_NAME:SetText(text.." - Fight : "..round(lastFight[1], 2).." sec")
	BLTRCD_MESSAGE:Clear()
	local tmp, tmp2, flag, flag2;
	local count = 0;
	for i,baseclass in pairs(BLRCD.classes) do
		flag2 = 0
		for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
			flag = 0;
			if cd[3].category == type then
				tmp = BLRCD.classes_color[baseclass] ..baseclass
				tmp = tmp .. BLRCD.classes_color["BLANK"] .. " : \124cffffd000\124Hspell:".. cd[3].spellID .."\124h"..cd[3].real_name.."\124h\124r"
				tmp = tmp .. " - \124cffff0000\124Hreport:"..cd[3].name..":"..cd[3].class..":"..cd[3].real_name..":"..cd[3].spellID.."\124h[Report]\124h\124r"
				for guid, value in pairs(lastFight[2][cd[3].class][cd[3].name]) do
					if (flag < 1) then
						BLTRCD_MESSAGE:AddMessage("=== "..tmp.." ===")
						count = count + 1;
						flag = 1;
						flag2 = 1;
					end
					BLTRCD_MESSAGE:AddMessage("   ".. BLRCD.classes_color[baseclass] .. value)
					count = count + 1;
				end
			end
			if (flag >= 1) then
				BLTRCD_MESSAGE:AddMessage(" ")
				count = count + 1
			end
		end
			if (flag2 >= 1) then
				BLTRCD_MESSAGE:AddMessage(" ")
				count = count + 1
			end
	end
	if (count <= 30) then
		BLTRCD_SCROLLBAR:SetMinMaxValues(0, 0)
	else
		BLTRCD_SCROLLBAR:SetMinMaxValues(0, count-30)
	end

	BLTRCD_SCROLLBAR:SetValue(1)
	BLTRCD_SCROLLBAR:SetValue(0)
end

function BUTTON_GLOBAL_OnClick()
	if lastFight == nil or next(lastFight) == nil then
		BLTRCD_ACTIVE_NAME:SetText("GLOBAL - Fight : No Last Fight")
		return
	end
	
	BLTRCD_ACTIVE_NAME:SetText("GLOBAL - Fight : "..round(lastFight[1], 2).." sec")
	BLTRCD_MESSAGE:Clear()
	local tmp, tmp2, flag, flag2;
	local count = 0;
	for i,baseclass in pairs(BLRCD.classes) do
		flag2 = 0
		for j, cd in ipairs(BLRCD['cd_helper'][baseclass]) do
			flag = 0;
			tmp = BLRCD.classes_color[baseclass] ..baseclass
			tmp = tmp .. BLRCD.classes_color["BLANK"] .. " : \124cffffd000\124Hspell:".. cd[3].spellID .."\124h"..cd[3].real_name.."\124h\124r"
			tmp = tmp .. " - \124cffff0000\124Hreport:"..cd[3].name..":"..cd[3].class..":"..cd[3].real_name..":"..cd[3].spellID.."\124h[Report]\124h\124r"
			for guid, value in pairs(lastFight[2][cd[3].class][cd[3].name]) do
				if (flag < 1) then
					BLTRCD_MESSAGE:AddMessage("=== "..tmp.." ===")
					count = count + 1;
					flag = 1;
					flag2 = 1;
				end
				BLTRCD_MESSAGE:AddMessage("   ".. BLRCD.classes_color[baseclass] .. value)
				count = count + 1;
			end
			if (flag >= 1) then
				BLTRCD_MESSAGE:AddMessage(" ")
				count = count + 1
			end
		end
			if (flag2 >= 1) then
				BLTRCD_MESSAGE:AddMessage(" ")
				count = count + 1
			end
	end
	if (count <= 30) then
		BLTRCD_SCROLLBAR:SetMinMaxValues(0, 0)
	else
		BLTRCD_SCROLLBAR:SetMinMaxValues(0, count-30)
	end
		BLTRCD_SCROLLBAR:SetValue(1)
		BLTRCD_SCROLLBAR:SetValue(0)
end

function BUTTON_AOE_HEAL_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("AOE_HEAL", "AOE_HEAL")
end

function BUTTON_SINGLE_HEAL_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("SINGLE_HEAL", "SINGLE_HEAL")
end

function BUTTON_MANA_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("MANA_REGEN", "MANA_REGEN")
end

function BUTTON_DPS_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("DPS", "AOE_DPS")
end	

function BUTTON_REZ_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("REZ", "REZ")
end

function BUTTON_DEFENSIVE_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("DEFENSIVE", "DEFENSIVE")
end

function BUTTON_MISC_OnClick()
	GENERAL_CHAT_DISPLAY_CAT("MISC", "MISC")
end

function BLTRCD_MESSAGE_OnLoad()
	BLTRCD_MESSAGE:SetHyperlinksEnabled(true)
	BLTRCD_MESSAGE:SetScript("OnHyperlinkClick", function(self,link,text,button) 
		local tmp;
		tmp = explode(':', link)
		if (tmp[1] == "spell") then
			SetItemRef(link,text,button) 
		else 
			local cooldown = {};
			cooldown.name = tmp[2]
			cooldown.class = tmp[3]
			cooldown.real_name = tmp[4]
			cooldown.spellID = tmp[5]
			BLRCD.ReportUsageCD(cooldown)
		end
	end)
	BLTRCD_MESSAGE:SetJustifyH("LEFT")
end	

function BLTRCD_SCROLLBAR_OnLoad()
	BLTRCD_SCROLLBAR:SetMinMaxValues(0, 45)
	BLTRCD_SCROLLBAR:SetValueStep(1)
	BLTRCD_SCROLLBAR.scrollStep = 1

	BLTRCD_SCROLLBAR:SetScript("OnValueChanged", function(self, value)
		BLTRCD_MESSAGE:SetScrollOffset(select(2, BLTRCD_SCROLLBAR:GetMinMaxValues()) - value)
	end)


	BLTRCD_SCROLLBAR:SetValue(0)

end	

function BLTRCD_DISPLAY_OnMouseWheel(self, delta)
	local cur_val = BLTRCD_SCROLLBAR:GetValue()
	local min_val, max_val = BLTRCD_SCROLLBAR:GetMinMaxValues()

	if delta < 0 and cur_val < max_val then
		cur_val = math.min(max_val, cur_val + 1)
		BLTRCD_SCROLLBAR:SetValue(cur_val)
	elseif delta > 0 and cur_val > min_val then
		cur_val = math.max(min_val, cur_val - 1)
		BLTRCD_SCROLLBAR:SetValue(cur_val)
	end
end

function BLTRCD_ENGAGE_OnClick()
		BLRCD.ReinitCDUsage()
		bossfight=true
		pullTime=GetTime()
end

function BLTRCD_DISENGAGE_OnClick()
	-- end fight boss
	bossfight=false

	-- snapshot CD usage
	lastFight={}
	lastFight[1]=GetTime()-pullTime
	BLRCD.snapshotCDusage()
		
	-- reset all CD > 5min
	for guid, tab_cd in pairs(BLRCD['handles']) do
		for spellID, handle in pairs(tab_cd) do
			-- handle[1] = cooldown
			-- handle[2] = handle stop timer
			-- handle[3] = bar
			if (handle[1][1].CD>=300) then
				BLRCD:StopCD(handle[1])
				BLRCD:CancelTimer(handle[2])
				handle[3]:Stop()
			end
		end
	end
end

function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    else
      print(formatting .. v)
    end
  end	
end

function BLTRCD_MESSAGE_OnShow()
	BUTTON_GLOBAL_OnClick()
end
